Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip4_var.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip4_var.h	(revision 331)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip4_var.h	(revision 331)
@@ -0,0 +1,268 @@
+/*
+ *  TINET (TCP/IP Protocol Stack)
+ * 
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
+ *                   Tomakomai National College of Technology, JAPAN
+ *
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã® (1)ï½(4) ã®æ¡ä»¶ãï¼Free Software Foundation 
+ *  ã«ãã£ã¦å
+¬è¡¨ããã¦ãã GNU General Public License ã® Version 2 ã«è¨
+ *  è¿°ããã¦ããæ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§ã¢ï¼æ¬ã½ããã¦ã§ã¢
+ *  ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼
+ *  å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®æ¡ä»¶ãæºãããã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ãã®é©ç¨å¯è½æ§ã
+ *  å«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´
+ *  æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ãã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  @(#) $Id$
+ */
+
+/*
+ * Copyright (c) 1982, 1986, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)ip_var.h	8.2 (Berkeley) 1/9/95
+ * $FreeBSD: src/sys/netinet/ip_var.h,v 1.45.2.1 1999/08/29 16:29:51 peter Exp $
+ */
+ 
+#ifndef _IP4_VAR_H_
+#define _IP4_VAR_H_
+
+/*
+ *  IPv4 ãããã»ãã¤ã­ã¼ãã¢ã¯ã»ã¹ãã¯ã­
+ */
+
+#define IF_IP4_HDR_SIZE			(IF_HDR_SIZE + IP4_HDR_SIZE)
+
+#define GET_IP4_HDR(nbuf)		((T_IP4_HDR*)((nbuf)->buf + IF_HDR_SIZE))
+#define GET_IP4_SDU(nbuf)		((uint8_t*)((nbuf)->buf) + GET_IF_IP4_HDR_SIZE(nbuf))
+
+#define GET_IP4_HDR_SIZE(nbuf)		((uint8_t)IP4_VHL_HL(GET_IP4_HDR(nbuf)->vhl) << 2)
+#define GET_IP4_SDU_SIZE(nbuf)		(ntohs(GET_IP4_HDR(nbuf)->len) - GET_IP4_HDR_SIZE(nbuf))
+#define GET_IF_IP4_HDR_SIZE(nbuf)	(IF_HDR_SIZE + (GET_IP4_HDR_SIZE(nbuf)))
+
+#define SET_IP4_SDU_SIZE(nbuf,slen)	(GET_IP4_HDR(nbuf)->len=(uint16_t)htons((slen) + IP4_HDR_SIZE))
+
+/*
+ *  IP ã® MSS ãµã¤ãºã®ãããã¯ã¼ã¯ãããã¡
+ */
+
+typedef struct t_net_buf_ip_mss {
+	uint16_t	len;	/* ãã¼ã¿ã®é·ã		*/
+	uint8_t		idix;	/* mpfid ã®ã¤ã³ããã¯ã¹	*/
+	uint8_t		flags;	/* ãã©ã°		*/
+#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
+	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
+#endif
+#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
+	uint8_t		halign[4 - IF_HDR_ALIGN];
+#endif
+	uint8_t		buf[IF_HDR_SIZE + IP4_MSS];
+				/* ãããã¡æ¬ä½		*/
+	} T_NET_BUF_IP_MSS;
+
+/*
+ *  65536 ãªã¯ããããµã¤ãºã®ãããã¯ã¼ã¯ãããã¡
+ */
+
+typedef struct t_net_buf4_65536 {
+	uint16_t	len;	/* ãã¼ã¿ã®é·ã		*/
+	uint8_t		idix;	/* mpfid ã®ã¤ã³ããã¯ã¹	*/
+	uint8_t		flags;	/* ãã©ã°		*/
+#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
+	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
+#endif
+#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
+	uint8_t		halign[4 - IF_HDR_ALIGN];
+#endif
+	uint8_t		buf[IF_IP4_HDR_SIZE + 65536];
+				/* ãããã¡æ¬ä½		*/
+#if defined(IF_PDU_HDR_PADDING)
+	uint8_t		padding[IF_PDU_HDR_PADDING];
+#endif				/* ãããã®ä½å		*/
+	} T_NET_BUF4_65536;
+
+#ifdef IP4_CFG_FRAGMENT
+
+/*
+ *  åæ§æã­ã¥ã¼ç¨ IPv4 ãããã®å®ç¾©
+ */
+
+typedef struct t_qip4_hdr {
+	uint8_t		vhl;		/* version << 4 | header length >> 2	*/
+					/* length ã¯ 4 octets åä½		*/
+	uint8_t		type;		/* type of services			*/
+	uint16_t	len;		/* total length				*/
+
+	uint16_t	id;		/* identification			*/
+	uint16_t	flg_off;	/* fragment flag & offset		*/
+
+	uint8_t		ttl;		/* time to live				*/
+	uint8_t		proto;		/* protocol				*/
+	uint16_t	sum;		/* checksum				*/
+
+	uint32_t	src;		/* source address			*/
+
+	T_NET_BUF	*next;		/* æ¬¡ã® IPv4 ãã©ã°ã¡ã³ã			*/
+	} __attribute__((packed, aligned(2))) T_QIP4_HDR;
+
+#define QIP4_HDR_SIZE			(sizeof(T_QIP4_HDR))
+#define IF_QIP4_HDR_SIZE		(IF_HDR_SIZE + QIP4_HDR_SIZE)
+
+#define GET_QIP4_HDR(nbuf)		((T_QIP4_HDR*)((nbuf)->buf + IF_HDR_SIZE))
+#define GET_QIP4_SDU(nbuf)		((uint8_t*)(nbuf)->buf + GET_IF_QIP4_HDR_SIZE(nbuf))
+
+#define GET_QIP4_HDR_SIZE(iph)		((uint8_t)IP4_VHL_HL((iph)->vhl) << 2)
+#define GET_IF_QIP4_HDR_SIZE(nbuf)	(IF_HDR_SIZE + (GET_QIP4_HDR_SIZE(GET_QIP4_HDR(nbuf))))
+
+/*
+ *  ãã¼ã¿ã°ã©ã åæ§æç¨ãããã¯ã¼ã¯ãããã¡
+ */
+
+typedef struct t_net_buf4_reassm {
+	uint16_t	len;	/* ãã¼ã¿ã®é·ã		*/
+	uint8_t		idix;	/* mpfid ã®ã¤ã³ããã¯ã¹	*/
+	uint8_t		flags;	/* ãã©ã°		*/
+#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
+	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
+#endif
+#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
+	uint8_t		align[4 - IF_HDR_ALIGN];
+#endif
+	uint8_t		buf[IP4_CFG_FRAG_REASSM_SIZE];
+				/* ãããã¡æ¬ä½		*/
+	} __attribute__((packed, aligned(2))) T_NET_BUF4_REASSM;
+
+#endif	/* of #ifdef IP4_CFG_FRAGMENT */
+
+/*
+ *  TCP ã®åæ§æã­ã¥ã¼ã«ããã IPv4 ãããã®å®ç¾©
+ */
+
+typedef struct t_ip4_tcp_q_hdr {
+	uint8_t		vhl;		/* version << 4 | header length >> 2	*/
+					/* length ã¯ 4 octets åä½		*/
+	uint8_t		type;		/* type of services			*/
+	uint16_t	len;		/* total length				*/
+
+	uint16_t	id;		/* identification			*/
+	uint16_t	flg_off;	/* fragment flag & offset		*/
+
+	uint8_t		ttl;		/* time to live				*/
+	uint8_t		proto;		/* protocol				*/
+	uint16_t	thoff;		/* TCP ãããã®ãªãã»ãã		*/
+
+	T_IN4_ADDR	src;		/* source address			*/
+	T_IN4_ADDR	dst;		/* destination address			*/
+	} __attribute__((packed, aligned(2))) T_IP4_TCP_Q_HDR;
+
+#ifdef SUPPORT_MIB
+
+/*
+ *  SNMP ã® ç®¡çæ
+å ±ãã¼ã¹ (MIB)
+ */
+
+typedef struct t_ip_stats {
+	uint32_t	ipInReceives;
+	uint32_t	ipInHdrErrors;
+	uint32_t	ipInAddrErrors;
+/*	uint32_t	ipForwDatagrams;*/
+	uint32_t	ipInUnknownProtos;
+/*	uint32_t	ipInDiscards;*/
+	uint32_t	ipInDelivers;
+	uint32_t	ipOutRequests;
+	uint32_t	ipOutDiscards;
+/*	uint32_t	ipOutNoRoutes;*/
+
+#ifdef IP4_CFG_FRAGMENT
+
+	uint32_t	ipReasmReqds;
+	uint32_t	ipReasmOKs;
+	uint32_t	ipReasmFails;
+	uint32_t	ipFragOKs;
+	uint32_t	ipFragFails;
+	uint32_t	ipFragCreates;
+
+#else	/* of #ifdef IP4_CFG_FRAGMENT */
+
+	uint32_t	ipReasmReqds;
+/*	uint32_t	ipReasmOKs;*/
+	uint32_t	ipReasmFails;
+/*	uint32_t	ipFragOKs;*/
+/*	uint32_t	ipFragFails;*/
+/*	uint32_t	ipFragCreates;*/
+
+#endif	/* of #ifdef IP4_CFG_FRAGMENT */
+
+} T_IP_STATS;
+
+extern T_IP_STATS ip_stats;
+
+#endif	/* of #ifdef SUPPORT_MIB */
+
+/*
+ *  é¢æ°
+ */
+
+extern void ip_frag_timer (void);
+extern void ip_init (void);
+extern ER ip_remove_options (T_NET_BUF *nbuf);
+extern ER ip_output (T_NET_BUF *nbuf, TMO tmout);
+extern void ip_exchg_addr (T_NET_BUF *nbuf);
+
+#endif	/* of #ifndef _IP4_VAR_H_ */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip6.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip6.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip6.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -102,6 +102,4 @@
 #define _IP6_H_
 
-#ifdef SUPPORT_INET6
-
 /*
  *  IPv6 の定義、RFC2460 参照
@@ -262,5 +260,5 @@
 
 /*
- *  IPv4 と IPv6 をコンパイル時に選択するためのマクロ
+ *  IPv6 と IPv4 をコンパイル時に選択するためのマクロ
  */
 
@@ -273,5 +271,5 @@
 /* ルータ通知を受信する場合は、通知された値 */
 
-#define IP_DEFTTL	ip6_defhlim
+#define IP6_DEFTTL	ip6_defhlim
 
 #else	/* #if NUM_ND6_DEF_RTR_ENTRY > 0 */
@@ -279,12 +277,17 @@
 /* ルータ通知を受信しない場合の値は既定値 */
 
-#define IP_DEFTTL	IPV6_DEFHLIM
+#define IP6_DEFTTL	IPV6_DEFHLIM
 
 #endif	/* #if NUM_ND6_DEF_RTR_ENTRY > 0 */
+
+/* IPv4 と IPv6 をコンパイル時に選択するためのマクロ */
+
+#ifdef _IP6_CFG
 
 #define IP_HDR_SIZE	IP6_HDR_SIZE
 #define T_IP_HDR	T_IP6_HDR
-
-#endif	/* of #ifdef SUPPORT_INET6 */
+#define IP_DEFTTL	IP6_DEFTTL
+
+#endif	/* of #ifdef _IP6_CFG */
 
 #endif	/* of #ifndef _IP6_H_ */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_icmp.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_icmp.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_icmp.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -76,4 +76,5 @@
 #include <t_syslog.h>
 #include "kernel_cfg.h"
+#include "tinet_cfg.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_ASP */
@@ -83,4 +84,5 @@
 #include <s_services.h>
 #include <t_services.h>
+#include "tinet_id.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_JSP */
@@ -95,4 +97,5 @@
 #include <net/ppp_ipcp.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_timer.h>
@@ -106,6 +109,10 @@
 #include <netinet/icmp_var.h>
 #include <netinet/tcp.h>
-#include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/udp_var.h>
+
+#include <net/if_var.h>
+
+#if defined(_IP4_CFG)
 
 /*
@@ -130,4 +137,5 @@
 static void icmp_unreach (T_NET_BUF *input, uint_t ihoff);
 
+#if defined(NUM_REDIRECT_ROUTE_ENTRY)
 #if NUM_REDIRECT_ROUTE_ENTRY > 0
 
@@ -135,4 +143,5 @@
 
 #endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */
+#endif	/* of #if defined(NUM_REDIRECT_ROUTE_ENTRY) */
 
 /*
@@ -147,32 +156,40 @@
 	T_IP4_HDR	*ip4h;
 	T_ICMP4_HDR	*icmp4h;
-	T_IN4_ADDR	addr;
+	T_IFNET		*ifp = IF_GET_IFNET();
 
 	NET_COUNT_MIB(icmp_stats.icmpInEchos, 1);
 
-	/* メッセージの型をエコー要求 (8) から エコー応答 (0) に	*/
-	/* 変更して送り返す。					*/
-
-	icmp4h = GET_ICMP4_HDR(input, ihoff);
-	icmp4h->type = ICMP4_ECHO_REPLY;
-
-	/* IP ヘッダの宛先と発信元を交換する。*/
-	ip4h      = GET_IP4_HDR(input);
-	addr      = ip4h->src;
-	ip4h->src = ip4h->dst;
-	ip4h->dst = addr;
-
-	/* チェックサムを計算する。*/
-	icmp4h->sum = 0;
-	icmp4h->sum = in_cksum(icmp4h,
-	                       (uint_t)(((input->len - GET_IF_IP4_HDR_SIZE(input)) + 3) >> 2 << 2));
-
-	/* 送信する。*/
-	NET_COUNT_ICMP4(net_count_icmp4.out_octets,
-	               input->len - GET_IF_IP4_HDR_SIZE(input));
-	NET_COUNT_ICMP4(net_count_icmp4.out_packets, 1);
-	NET_COUNT_MIB(icmp_stats.icmpOutMsgs, 1);
-	NET_COUNT_MIB(icmp_stats.icmpOutEchoReps, 1);
-	ip_output(input, TMO_ICMP_OUTPUT);
+	/* IPv4 アドレスが未定義の時は応答しない。*/
+	if (!IN4_IS_ADDR_ANY(&ifp->in4_ifaddr.addr)) {
+
+		/*
+		 *  メッセージの型をエコー要求 (8) から
+		 *  エコー応答 (0) に変更して送り返す。
+		 */
+
+		icmp4h = GET_ICMP4_HDR(input, ihoff);
+		icmp4h->type = ICMP4_ECHO_REPLY;
+
+		/*
+		 *  宛先アドレスは受信したメッセージの送信元アドレス。
+		 *  送信元アドレスは自 IPv4 アドレス。
+		 */
+		ip4h      = GET_IP4_HDR(input);
+		ip4h->dst = ip4h->src;
+		ip4h->src = htonl(ifp->in4_ifaddr.addr);
+
+		/* チェックサムを計算する。*/
+		icmp4h->sum = 0;
+		icmp4h->sum = in_cksum(icmp4h,
+		                       (uint_t)(((input->len - GET_IF_IP4_HDR_SIZE(input)) + 3) >> 2 << 2));
+
+		/* 送信する。*/
+		NET_COUNT_ICMP4(net_count_icmp4.out_octets,
+		               input->len - GET_IF_IP4_HDR_SIZE(input));
+		NET_COUNT_ICMP4(net_count_icmp4.out_packets, 1);
+		NET_COUNT_MIB(icmp_stats.icmpOutMsgs, 1);
+		NET_COUNT_MIB(icmp_stats.icmpOutEchoReps, 1);
+		ip_output(input, TMO_ICMP_OUTPUT);
+		}
 	}
 
@@ -212,13 +229,24 @@
 	code  = GET_ICMP4_HDR(input, ihoff)->code;
 	error = code2error[code];
-	if (ip4h->proto == IPPROTO_TCP) {
-
-#ifdef SUPPORT_TCP
+
+	/* 最終ヘッダが TCP/UDP のみ対応する。*/
+	if (ip4h->proto == IPPROTO_TCP || ip4h->proto == IPPROTO_UDP) {
 
 		memcpy(GET_IP4_HDR(input), ip4h, input->len - (IP4_HDR_SIZE + ICMP4_HDR_SIZE));
 		input->len -= IP4_HDR_SIZE + ICMP4_HDR_SIZE;
-		tcp_notify(input, error);
-
-#endif	/* of #ifdef SUPPORT_TCP */
+
+#if defined(SUPPORT_TCP)
+
+		if (ip4h->proto == IPPROTO_TCP)
+			tcp_notify(input, error);
+
+#endif	/* of #if defined(SUPPORT_TCP) */
+
+#if defined(SUPPORT_UDP) && TNUM_UDP4_CEPID > 0
+
+		if (ip4h->proto == IPPROTO_UDP)
+			udp4_notify(input, error);
+
+#endif	/* of #if defined(SUPPORT_UDP) && TNUM_UDP4_CEPID > 0 */
 
 		}
@@ -227,4 +255,5 @@
 	}
 
+#if defined(NUM_REDIRECT_ROUTE_ENTRY)
 #if NUM_REDIRECT_ROUTE_ENTRY > 0
 
@@ -264,4 +293,5 @@
 
 #endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */
+#endif	/* of #if defined(NUM_REDIRECT_ROUTE_ENTRY) */
 
 /*
@@ -314,9 +344,9 @@
 	case ICMP4_ECHO_REPLY:
 
-#ifdef ICMP_CFG_CALLBACK_ECHO_REPLY
+#if defined(SUPPORT_INET4) && defined(ICMP_CFG_CALLBACK_ECHO_REPLY)
 
 		icmp_echo_reply(input, *offp);
 
-#endif	/* of #ifdef ICMP_CFG_CALLBACK_ECHO_REPLY */
+#endif	/* of #if defined(SUPPORT_INET4) && defined(ICMP_CFG_CALLBACK_ECHO_REPLY) */
 
 		break;
@@ -326,4 +356,5 @@
 	case ICMP4_REDIRECT:
 
+#if defined(NUM_REDIRECT_ROUTE_ENTRY)
 #if NUM_REDIRECT_ROUTE_ENTRY > 0
 
@@ -338,4 +369,10 @@
 
 #endif	/* of #if NUM_REDIRECT_ROUTE_ENTRY > 0 */
+#else	/* of #if defined(NUM_REDIRECT_ROUTE_ENTRY) */
+
+		addr = ntohl(icmp4h->data.addr);
+		syslog(LOG_INFO, "[ICMP] redirect ignored, addr: %s.", ip2str(NULL, &addr));
+
+#endif	/* of #if defined(NUM_REDIRECT_ROUTE_ENTRY) */
 
 		break;
@@ -371,5 +408,5 @@
 
 	ip4h  = GET_IP4_HDR(input);
-	ip4hl = GET_IP4_HDR_SIZE(ip4h);
+	ip4hl = GET_IP4_HDR_SIZE(input);
 
 	/* 送信用の IP データグラムを獲得する。*/
@@ -378,5 +415,5 @@
 	else
 		len = 8;
-
+	
 	saddr = ntohl(ip4h->src);
 	if (in4_get_datagram(&output, (uint_t)(ICMP4_HDR_SIZE + ip4hl + len), 0,
@@ -417,2 +454,4 @@
 
 #endif	/* of #ifdef ICMP_REPLY_ERROR */
+
+#endif	/* of #if defined(_IP4_CFG) */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_icmp.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_icmp.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_icmp.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -71,4 +71,6 @@
 #define _IP_ICMP_H_
 
+#include <netinet/icmp6.h>
+
 /*
  *  ICMP ヘッダの定義、RFC 792
@@ -96,7 +98,7 @@
 #define GET_ICMP4_SDU(nbuf,ihoff)	((uint8_t*)((nbuf)->buf) + ihoff + ICMP4_HDR_SIZE)
 
-#define GET_ICMP4_HDR_OFFSET(nbuf)	(GET_IF_IP_HDR_SIZE(nbuf))
+#define GET_ICMP4_HDR_OFFSET(nbuf)	(GET_IF_IP4_HDR_SIZE(nbuf))
 
-#define GET_IP4_ICMP4_HDR_SIZE(nbuf)	(GET_IP4_HDR_SIZE(GET_IP4_HDR(nbuf)) + ICMP4_HDR_SIZE)
+#define GET_IP4_ICMP4_HDR_SIZE(nbuf)	(GET_IP4_HDR_SIZE(nbuf) + ICMP4_HDR_SIZE)
 #define GET_IF_IP4_ICMP4_HDR_SIZE(nbuf)	(IF_HDR_SIZE + GET_IP4_ICMP4_HDR_SIZE(nbuf))
 
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.c	(revision 331)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.c	(revision 331)
@@ -0,0 +1,409 @@
+/*
+*  TINET (TCP/IP Protocol Stack)
+*
+*  Copyright (C) 2001-2012 by Dep. of Computer Science and Engineering
+*                   Tomakomai National College of Technology, JAPAN
+*
+*  ãLì ÒÍCÈºÌ (1)`(4) Ìð©CFree Software Foundation
+*  ÉæÁÄö\³êÄ¢é GNU General Public License Ì Version 2 ÉL
+*  q³êÄ¢éðð½·êÉÀèC{\tgEFAi{\tgEFA
+*  ðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏEÄzziÈºC
+*  pÆÄÔj·é±Æð³Åø·éD
+*  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì
+*       \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[
+*      XR[hÉÜÜêÄ¢é±ÆD
+*  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Ég
+*      pÅ«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
+gip
+*      Ò}j
+AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºL
+*      Ì³ÛØKèðfÚ·é±ÆD
+*  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Ég
+*      pÅ«È¢`ÅÄzz·éêÉÍCÌðð½·±ÆD
+*    (a) ÄzzÉº¤hL
+gipÒ}j
+AÈÇjÉCãLÌ
+*        ì \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
+*  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹
+*      Q©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
+*
+*  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨
+*  æÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄC»ÌKpÂ\«à
+*  ÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌpÉæè¼
+*  ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCðíÈ¢D
+*
+*  @(#) $Id$
+*/
+
+#include <string.h>
+
+#ifdef TARGET_KERNEL_ASP
+
+#include <kernel.h>
+#include <sil.h>
+#include <t_syslog.h>
+#include "kernel_cfg.h"
+#include "tinet_cfg.h"
+
+#endif	/* of #ifdef TARGET_KERNEL_ASP */
+
+#ifdef TARGET_KERNEL_JSP
+
+#include <s_services.h>
+#include <t_services.h>
+#include "tinet_id.h"
+
+#endif	/* of #ifdef TARGET_KERNEL_JSP */
+
+#include <tinet_defs.h>
+#include <tinet_config.h>
+
+#include <net/if.h>
+#include <net/if_loop.h>
+#include <net/if_ppp.h>
+#include <net/ethernet.h>
+#include <net/ppp_ipcp.h>
+#include <net/net.h>
+#include <net/net_endian.h>
+#include <net/net_buf.h>
+#include <net/net_timer.h>
+#include <net/net_count.h>
+
+#include <netinet/in.h>
+#include <netinet/in_var.h>
+#include <netinet/ip.h>
+#include <netinet/ip_var.h>
+#include <netinet/tcp.h>
+#include <netinet/tcp_var.h>
+#include <netinet/udp_var.h>
+#include <netinet/ip_igmp.h>
+
+#include <net/if_var.h>
+#include <net/net_var.h>
+
+#ifdef SUPPORT_IGMP
+
+static T_IGMP_ENTRY igmp_groups[NUM_IGMP_ENTRY];
+static T_IN4_ADDR igmp_send_addrs[NUM_IGMP_ENTRY];
+
+static bool_t igmp_send_report_v2(T_IN4_ADDR dst);
+static uint16_t igmp_get_timer(T_IGMP_ENTRY *entry);
+
+ER igmp_set_loop(T_UDP_CEP *cep, uint8_t optval)
+{
+	switch (optval) {
+	case 0:
+		cep->igmp_loopback = false;
+		return E_OK;
+	case 1:
+		cep->igmp_loopback = true;
+		return E_OK;
+	}
+
+	return E_PAR;
+}
+
+ER igmp_get_loop(T_UDP_CEP *cep, uint8_t *optval)
+{
+	if (optval == NULL)
+		return E_PAR;
+
+	*optval = cep->igmp_loopback ? 1 : 0;
+
+	return E_OK;
+}
+
+ER igmp_set_ttl(T_UDP_CEP *cep, uint8_t optval)
+{
+	cep->igmp_ttl = optval;
+
+	return E_OK;
+}
+
+ER igmp_get_ttl(T_UDP_CEP *cep, uint8_t *optval)
+{
+	if (optval == NULL)
+		return E_PAR;
+
+	*optval = cep->igmp_ttl;
+
+	return E_OK;
+}
+
+ER igmp_set_if(T_UDP_CEP *cep, T_IN4_ADDR *optval)
+{
+	if (optval == NULL)
+		return E_PAR;
+
+	cep->igmp_mcaddr = *optval;
+
+	return E_OK;
+}
+
+ER igmp_get_if(T_UDP_CEP *cep, T_IN4_ADDR *optval)
+{
+	if (optval == NULL)
+		return E_PAR;
+
+	*optval = cep->igmp_mcaddr;
+
+	return E_OK;
+}
+
+ER igmp_add_membership(T_UDP_CEP *cep, T_IP_MREQ *optval)
+{
+	T_IGMP_ENTRY *entry = NULL;
+	int		i;
+	uint16_t	min;
+	T_IFNET	*ifp = IF_GET_IFNET();
+	ER ret = E_NOMEM;
+
+	if ((optval->imr_interface != IPV4_ADDRANY)
+		&& (optval->imr_interface != ifp->in4_ifaddr.addr))
+		return E_PAR;
+
+	syscall(wai_sem(SEM_IGMP_GROUP_LOCK));
+
+	for (i = 0; i < NUM_IGMP_ENTRY; i++) {
+		entry = &igmp_groups[i];
+		if (entry->timer == -1) {
+			entry->timer = igmp_get_timer(entry);
+			entry->ip_addr = optval->imr_multiaddr;
+			ret = E_OK;
+			break;
+		}
+	}
+
+	syscall(sig_sem(SEM_IGMP_GROUP_LOCK));
+
+	return ret;
+}
+
+ER igmp_drop_membership(T_UDP_CEP *cep, T_IP_MREQ *optval)
+{
+	T_IGMP_ENTRY *entry = NULL;
+	int		i;
+	uint16_t	min;
+	ER ret = E_PAR;
+	T_IFNET	*ifp = IF_GET_IFNET();
+
+	if ((optval->imr_interface != IPV4_ADDRANY)
+		&& (optval->imr_interface != ifp->in4_ifaddr.addr))
+		return E_PAR;
+
+	syscall(wai_sem(SEM_IGMP_GROUP_LOCK));
+
+	for (i = 0; i < NUM_IGMP_ENTRY; i++) {
+		entry = &igmp_groups[i];
+		if ((entry->timer >= 0) && (entry->ip_addr == optval->imr_multiaddr)) {
+			entry->timer = -1;
+			entry->ip_addr = 0;
+			ret = E_OK;
+			break;
+		}
+	}
+
+	syscall(sig_sem(SEM_IGMP_GROUP_LOCK));
+
+	return ret;
+}
+
+ER igmp_set_ip_msfilter(T_UDP_CEP *cep, const T_IP_MSFILTER *optval)
+{
+	return E_PAR;
+}
+
+ER igmp_get_ip_msfilter(T_UDP_CEP *cep, T_IP_MSFILTER *optval)
+{
+	return E_PAR;
+}
+
+uint_t igmp_input(T_NET_BUF **inputp, uint_t *offp, uint_t *nextp)
+{
+	T_NET_BUF	*input = *inputp;
+	T_IGMPV2_HDR	*igmph;
+	T_IN4_ADDR	addr;
+	uint_t		len, align;
+	T_IP4_HDR	*ip4h;
+	int i;
+	T_IGMP_ENTRY *entry;
+	bool_t ret;
+
+	NET_COUNT_IGMP(net_count_igmp.in_octets,
+		input->len - GET_IF_IP4_HDR_SIZE(input));
+	NET_COUNT_IGMP(net_count_igmp.in_packets, 1);
+
+	/* ICMP wb_Ì·³ð`FbN·éB*/
+	if (input->len < IF_IP4_IGMP_HDR_SIZE) {
+		NET_COUNT_IGMP(net_count_igmp.in_err_packets, 1);
+		NET_COUNT_MIB(igmp_stats.igmpInErrors, 1);
+		goto buf_rel;
+	}
+
+	igmph = (T_IGMPV2_HDR *)(input->buf + *offp);
+
+	/* 4 INebg«EÌf[^· */
+	len = input->len - *offp;
+	align = (len + 3) >> 2 << 2;
+
+	/* 4 INebg«EÜÅpfBOÅßéB*/
+	if (align > len)
+		memset((uint8_t*)input->buf + input->len, 0, (size_t)(align - len));
+
+	/* `FbNTðvZ·éB*/
+	if (in_cksum(igmph, align) != 0) {
+		NET_COUNT_IGMP(net_count_igmp.in_err_packets, 1);
+		goto buf_rel;
+	}
+
+	/* bZ[WÌ^Éæèªò·éB*/
+	switch (igmph->type) {
+	case IGMP_MEMBERSHIP_QUERY:
+		ip4h = GET_IP4_HDR(input);
+		ret = false;
+
+		/* QÁÌO[vAhX©çÌNG[Ìê */
+		syscall(wai_sem(SEM_IGMP_GROUP_LOCK));
+
+		for (i = 0; i < NUM_IGMP_ENTRY; i++) {
+			entry = &igmp_groups[i];
+			if ((entry->timer >= 0) && (entry->ip_addr == addr)) {
+				entry->resptime = igmph->time;
+				ret = true;
+				break;
+			}
+		}
+
+		syscall(sig_sem(SEM_IGMP_GROUP_LOCK));
+
+		if (ret) {
+			/* o[Vbv|[gðM */
+			igmp_send_report_v2(ip4h->src);
+		}
+		break;
+	}
+
+buf_rel:
+	syscall(rel_net_buf(input));
+	return IPPROTO_DONE;
+}
+
+static bool_t igmp_send_report_v2(T_IN4_ADDR dst)
+{
+	T_IGMPV2_HDR	*igmph;
+	T_NET_BUF		*output;
+	uint_t			len, align;
+
+	if (in4_get_datagram(&output, (uint_t)(IF_IP4_IGMP_HDR_SIZE + len), 0,
+		&dst, NULL, IPPROTO_IGMP, IP4_DEFTTL,
+		NBA_SEARCH_ASCENT, TMO_IGMP_OUTPUT) != E_OK)
+		return false;
+
+	/* IGMP wb_ðÝè·éB*/
+	igmph = GET_IGMPV2_HDR(output, IF_IP4_IGMP_HDR_OFFSET);
+	igmph->type = IGMP_MEMBERSHIP_REPORT_V2;
+	igmph->time = 0;
+	igmph->addr = dst;
+
+	/* 4 INebg«EÌf[^· */
+	align = (len + 3) >> 2 << 2;
+
+	/* 4 INebg«EÜÅpfBOÅßéB*/
+	if (align > len)
+		memset((uint8_t*)GET_IGMP_SDU(output, IF_IP4_IGMP_HDR_OFFSET) + IP4_HDR_SIZE + len,
+			0, (size_t)(align - len));
+
+	/* `FbNTðvZ·éB*/
+	igmph->sum = 0;
+	igmph->sum = in_cksum(igmph, (uint_t)(IF_IP4_IGMP_HDR_SIZE + align));
+
+	/* M·éB*/
+	NET_COUNT_IGMP(net_count_igmp.out_octets,
+		output->len - GET_IF_IP4_HDR_SIZE(output));
+	NET_COUNT_IGMP(net_count_igmp.out_packets, 1);
+	NET_COUNT_MIB(icmp_stats.icmpOutMsgs, 1);
+	NET_COUNT_MIB(icmp_stats.icmpOutDestUnreachs, 1);
+	ip_output(output, TMO_IGMP_OUTPUT);
+
+	return true;
+}
+
+/*
+*  igmp_timer -- IGMP ¤Ê^C}[
+*/
+static void igmp_timer(void *ignore)
+{
+	T_IGMP_ENTRY *entry = NULL;
+	int i, j = 0;
+
+	/* memset(igmp_send_addrs, 0, sizeof(igmp_send_addrs)); */
+
+	syscall(wai_sem(SEM_IGMP_GROUP_LOCK));
+
+	for (i = 0; i < NUM_IGMP_ENTRY; i++) {
+		entry = &igmp_groups[i];
+		if (entry->timer > 0)
+			entry->timer--;
+		if (entry->timer == 0) {
+			entry->timer = igmp_get_timer(entry);
+			igmp_send_addrs[j++] = entry->ip_addr;
+		}
+	}
+
+	syscall(sig_sem(SEM_IGMP_GROUP_LOCK));
+
+	for (i = 0; i < j; i++) {
+		igmp_send_report_v2(igmp_send_addrs[i]);
+	}
+
+	timeout(igmp_timer, NULL, NET_TIMER_HZ / 1);
+}
+
+/*
+*  igmp_init -- IGMP @\ðú»·éB
+*/
+
+void igmp_init(void)
+{
+	T_IGMP_ENTRY *entry = NULL;
+	int i;
+
+	for (i = 0; i < NUM_IGMP_ENTRY; i++) {
+		igmp_groups[i].timer = -1;
+	}
+
+	timeout(igmp_timer, NULL, NET_TIMER_HZ / 1);
+}
+
+bool_t igmp_is_joined_group(T_IN4_ADDR addr)
+{
+	T_IGMP_ENTRY *entry = NULL;
+	int		i;
+	bool_t ret = false;
+
+	syscall(wai_sem(SEM_IGMP_GROUP_LOCK));
+
+	for (i = 0; i < NUM_IGMP_ENTRY; i++) {
+		entry = &igmp_groups[i];
+		if ((entry->timer >= 0) && (entry->ip_addr == addr)) {
+			ret = true;
+			break;
+		}
+	}
+
+	syscall(sig_sem(SEM_IGMP_GROUP_LOCK));
+
+	return ret;
+}
+
+uint16_t igmp_get_timer(T_IGMP_ENTRY *entry)
+{
+	uint16_t time = entry->resptime;
+
+	if (time == 0)
+		time = 10;
+
+	return net_rand() / (0x7fffffff / time);
+}
+
+#endif /* of #ifdef SUPPORT_IGMP */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.cfg	(revision 331)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.cfg	(revision 331)
@@ -0,0 +1,49 @@
+/*
+ *  TINET (TCP/IP Protocol Stack)
+ * 
+ *  Copyright (C) 2001-2012 by Dep. of Computer Science and Engineering
+ *                   Tomakomai National College of Technology, JAPAN
+ *
+ *  ãLì ÒÍCÈºÌ (1)`(4) Ìð©CFree Software Foundation 
+ *  ÉæÁÄö\³êÄ¢é GNU General Public License Ì Version 2 ÉL
+ *  q³êÄ¢éðð½·êÉÀèC{\tgEFAi{\tgEFA
+ *  ðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏEÄzziÈºC
+ *  pÆÄÔj·é±Æð³Åø·éD
+ *  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì
+ *       \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[
+ *      XR[hÉÜÜêÄ¢é±ÆD
+ *  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Ég
+ *      pÅ«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
+gip
+ *      Ò}j
+AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºL
+ *      Ì³ÛØKèðfÚ·é±ÆD
+ *  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Ég
+ *      pÅ«È¢`ÅÄzz·éêÉÍCÌðð½·±ÆD
+ *    (a) ÄzzÉº¤hL
+gipÒ}j
+AÈÇjÉCãLÌ
+ *        ì \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
+ *  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹
+ *      Q©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
+ *
+ *  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨
+ *  æÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄC»ÌKpÂ\«à
+ *  ÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌpÉæè¼
+ *  ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCðíÈ¢D
+ * 
+ *  @(#) $Id$
+ */
+
+/*
+ *  IGMP RtBM
+[Vt@C
+ */
+
+#if defined(_IP4_CFG) && defined(SUPPORT_IGMP)
+
+/* IGMP O[vXVpZ}tH */
+
+CRE_SEM(SEM_IGMP_GROUP_LOCK, { TA_TPRI, 1, 1 });
+
+#endif	/* of #if defined(_IP4_CFG) && defined(SUPPORT_IGMP) */
